﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace picfiltergui
{
    public partial class viewer : Form
    {
        public List<String> listOfFiles { get; set; }
        private List<bool> _to_save { get; set; }
        List<CheckBox> pics { get; set; }
        public int start, end, saveUnsorted, success;
        public string folder_name;
        
        
        public viewer()
        {
            InitializeComponent();
            listOfFiles = new List<String>();
            pics = new List<CheckBox>();
            _to_save = new List<bool>();
            start = 0;
            end = 0;
            success = 0;

        }

        private void viewer_Load(object sender, EventArgs e)
        {
            if (listOfFiles[start] == "@@")
                select_pictures();
        }


        public void select_pictures()
        {   
            start = end + 1;
            end++;
            
            _to_save.Add(true);
            while (listOfFiles[end] != "@@")
            {  
                end++;
                if (end == listOfFiles.Count - 2)
                    break;
            }
            show_pictures(start, end);// showing the pics to the user
        }

 
        private void show_pictures(int temp_start, int temp_end)
        {
            int column = 0, row = 0;
            for (int i = 0; temp_start < temp_end; temp_start++, i++)
            {
                if (column == 3)
                {
                    column = 0;
                    row++;
                }
                CheckBox newpic = new CheckBox();
                newpic.Appearance = Appearance.Button;
                newpic.SetBounds(rectangleShape1.Location.X + (column * (rectangleShape1.Size.Width / 3)), rectangleShape1.Location.Y + (row * (rectangleShape1.Size.Width / 3)), (rectangleShape1.Size.Width / 3), (rectangleShape1.Size.Height / 3));
                
                newpic.BackgroundImage = new Bitmap(listOfFiles[temp_start]);
                newpic.BackgroundImageLayout = ImageLayout.Stretch;
                
                pics.Add(newpic);
                Controls.AddRange(new System.Windows.Forms.Control[] { newpic });
                column++;
            }
        }


        private void next_button_Click(object sender, EventArgs e)
        {            
           for (int j = 0; j < pics.Count; j++)
                if (pics[j].Checked)
                    _to_save.Add(true);
                else
                    _to_save.Add(false);


           for (int k = 0; k < pics.Count; k++)
           {
               Controls.Remove(pics[k]);
               pics[k].BackgroundImage.Dispose();
           }
           pics.Clear();


            if (end != listOfFiles.Count - 2)
                select_pictures();
            else 
                 {
                    for (int i = 0; i < _to_save.Count; i++)
                            if ((_to_save[i] != true) && (listOfFiles[i] != "@@") && (listOfFiles[i] != "@"))
                            {
                                string temp_path = Path.GetDirectoryName(listOfFiles[i]) + "\\" + folder_name;
                                string new_path = temp_path + "\\" + Path.GetFileName(listOfFiles[i]);
                                if (saveUnsorted == 1)
                                {
                                    if (!File.Exists(temp_path))
                                        System.IO.Directory.CreateDirectory(temp_path);
                                    File.Copy(listOfFiles[i], new_path);
                                }
                                File.Delete(listOfFiles[i]);
                            }
                        success = 1;
                        viewer.ActiveForm.Close();
                    }
        }


        private void rectangleShape1_Click(object sender, EventArgs e)
        {

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }
    }
}